
import 'package:flutter/material.dart';
import 'package:nirrti/nirrti.dart';
import 'package:nirrti/src/custom_components/custom_autocomplete/dropdown_container/view_model.dart';

mixin ViewMixin {
  render(BuildContext context, DropDownContainerState state) {
    return ConstrainedBox(
      constraints: BoxConstraints(
        minWidth: state.widget.width ?? 200,
        maxWidth: state.widget.width ?? 200,
        maxHeight: 120,
      ),
      child: Container(
        decoration: ShapeDecoration(
          color: Colors.white,
          shape: RoundedRectangleBorder(
            side: BorderSide(
              width: 1,
              color: Artist().inputBorderColor,
            ),
            borderRadius: Artist().defaultBorderRadius,
          ),
        ),
        child: ListView(
          children: [
            for (AutocompleteOption item in state.widget.optionsList)
            InkWell(
              onTap: () {
                state.widget.onClickOption(item);
              },
              child: IgnorePointer(
                child: item.widget,
              )
            ),
          ],
        )
      )
    );
  }
}