import 'package:flutter/material.dart';
import 'package:nirrti/src/custom_components/custom_autocomplete/view_model.dart';
import 'package:nirrti/src/custom_components/custom_input/view_model.dart';
import 'dropdown_container/view_model.dart';

mixin ViewMixin {
  render(BuildContext context, OwlnextAutocompleteState state) {
    return LayoutBuilder(
      builder: (BuildContext context, BoxConstraints constraints) { 
        return CompositedTransformTarget(
          link: state.link,
          child: OverlayPortal(
            controller: state.portalController,
            child: SizedBox(
              child: OwlnextInput(
                label: state.widget.label,
                controller: state.widget.controller,
                onChanged: state.widget.onChange,
                isInsideList: false,
                focus: state.focus,
              ),
            ),
            overlayChildBuilder: (BuildContext context) {
              return CompositedTransformFollower(
                showWhenUnlinked: false,
                link: state.link,
                offset: const Offset(0, 75),
                targetAnchor: Alignment.topLeft,
                child: Align(
                  alignment: AlignmentDirectional.topStart,
                  child: DropDownContainer(
                    width: state.inputWidth,
                    optionsList: state.widget.optionsList,
                    tooltipController: state.portalController,
                    onClickOption: state.onSelect,
                    label: state.widget.label,
                  )
                ),
              );
            },
          ),
        );
      }
    );
  }
}